package com.qmth.cqb.paper.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import com.qmth.cqb.paper.model.PaperDetailInfoUnitStructBlueprint;

/**
 * @describle 蓝图试卷结构大题详情属性数量repo
 * @author weiwenhai
 * @date   2017.11.20
 */
public interface PaperDetailInfoUnitStructBlueprintRepo extends JpaRepository<PaperDetailInfoUnitStructBlueprint, Long>,QueryByExampleExecutor<PaperDetailInfoUnitStructBlueprint>,JpaSpecificationExecutor<PaperDetailInfoUnitStructBlueprint>{

	@Query("select s from PaperDetailInfoUnitStructBlueprint s where s.paperDetailInfoStructBlueprintId =?1 and s.paperDetailStructBlueprintId = ?2 group by s.propertyId order by s.id")
	List<PaperDetailInfoUnitStructBlueprint> findGroupByPropertyId(Long paperDetailInfoStructBlueprintId, Long paperDetailStructBlueprintId);
	
	List<PaperDetailInfoUnitStructBlueprint> findByPaperDetailInfoStructBlueprintIdAndPaperDetailStructBlueprintId(Long paperDetailInfoStructBlueprintId, Long paperDetailStructBlueprintId);
	
	PaperDetailInfoUnitStructBlueprint findByPaperDetailInfoStructBlueprintIdAndPaperDetailStructBlueprintIdAndPropertyIdAndIsPublicAndPropertyDifficulty(Long paperDetailInfoStructBlueprintId, Long paperDetailStructBlueprintId, Long propertyId, Boolean isPublic, String propertyDifficulty);
	
	List<PaperDetailInfoUnitStructBlueprint> findByPropertyIdAndIsPublicAndPropertyDifficulty(Long propertyId, Boolean isPublic, String propertyDifficulty);
}
