package com.qmth.cqb.paper.model;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.qmth.cqb.paper.dto.PaperStructBlueprintDto;

/**
 * @describle 蓝图试卷结构
 * @author weiwenhai
 * @date   2017.11.15
 */
@Entity
@Table(name = "ecs_ques_paper_struct_blueprint")
public class PaperStructBlueprint implements Serializable{

	private static final long serialVersionUID = -5738577530345514442L;
	
	@Id
	@GeneratedValue
	private Long id; //id
	
	@NotNull
	private String name; //蓝图结构名称
	
	@NotNull
	private String courseNo; //制定课程
	
	private Long coursePropertyId; //课程属性
	
	private Integer detailCount; //大题数量
	
	private Double totalScore; //总分
	
	private Double difficulty; //难度 
	
	@NotNull
	private String type; //设置类型
	
	@NotNull
	private Long orgId; //机构ID
	
	@NotNull
	private String creator; //创建人id
	
	private String updateCreator; //修改人
	
    private Date createTime; //创建时间
    
    private Date updateTime; //修改时间

    public PaperStructBlueprint(){}
    
    public PaperStructBlueprint(PaperStructBlueprintDto paperStructBlueprintDto){
    	this.id = paperStructBlueprintDto.getId();
    	this.name = paperStructBlueprintDto.getName();
    	this.courseNo = paperStructBlueprintDto.getCourseCode();
    	this.coursePropertyId = paperStructBlueprintDto.getCoursePropertyId();
    	this.totalScore = paperStructBlueprintDto.getTotalScore();
    	this.type = paperStructBlueprintDto.getType();
    	this.creator = paperStructBlueprintDto.getCreator();
    	this.orgId = paperStructBlueprintDto.getOrgId();
    }
    
    public Double getDifficulty() {
		return difficulty;
	}

	public void setDifficulty(Double difficulty) {
		this.difficulty = difficulty;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Integer getDetailCount() {
		return detailCount;
	}

	public void setDetailCount(Integer detailCount) {
		this.detailCount = detailCount;
	}

	public Double getTotalScore() {
		return totalScore;
	}

	public void setTotalScore(Double totalScore) {
		this.totalScore = totalScore;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
	
	public String getCreator() {
		return creator;
	}

	public void setCreator(String creator) {
		this.creator = creator;
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	public Long getOrgId() {
		return orgId;
	}

	public void setOrgId(Long orgId) {
		this.orgId = orgId;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public String getUpdateCreator() {
		return updateCreator;
	}

	public void setUpdateCreator(String updateCreator) {
		this.updateCreator = updateCreator;
	}

	public Date getUpDateTime() {
		return updateTime;
	}

	public void setUpDateTime(Date updateTime) {
		this.updateTime = updateTime;
	}

	public String getCourseNo() {
		return courseNo;
	}

	public void setCourseNo(String courseNo) {
		this.courseNo = courseNo;
	}

	public Long getCoursePropertyId() {
		return coursePropertyId;
	}

	public void setCoursePropertyId(Long coursePropertyId) {
		this.coursePropertyId = coursePropertyId;
	}

	public Date getUpdateTime() {
		return updateTime;
	}

	public void setUpdateTime(Date updateTime) {
		this.updateTime = updateTime;
	}
    
}
