package com.qmth.cqb.paper.service;

import java.util.List;

import com.qmth.cqb.paper.model.PaperDetailStructBlueprint;

/**
 * @describle 蓝图试卷结构大题 service
 * @author weiwenhai
 * @date   2017.11.20
 */
public interface PaperDetailStructBlueprintService {
	
	/**
	 * 根据试卷结构id
	 * 查询所有大题，不带分页
	 * @param paperStructBlueprintId
	 * @return
	 */
	public List<PaperDetailStructBlueprint> findAll(Long paperStructBlueprintId);
	
	/**
	 * 查询新增的大题，无试卷结构id
	 * @param userId
	 * @param paperStructBlueprintId
	 * @return
	 */
	public List<PaperDetailStructBlueprint> findSaveAll(Long userId, Long paperStructBlueprintId);
	
	/**
	 * 保存新增的单个大题
	 * @param paperDetailStructBlueprint
	 */
	public void saveSingle(PaperDetailStructBlueprint paperDetailStructBlueprint);
	
	/**
	 * 删除单个大题
	 * @param id
	 */
	public void deleteSingle(Long id);
}
