package com.qmth.cqb.paper.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import com.ctc.wstx.util.StringUtil;
import com.netflix.infix.lang.infix.antlr.EventFilterParser.null_predicate_return;
import com.qmth.cqb.paper.dao.PaperDetailStructBlueprintRepo;
import com.qmth.cqb.paper.model.PaperDetailInfoStructBlueprint;
import com.qmth.cqb.paper.model.PaperDetailInfoUnitStructBlueprint;
import com.qmth.cqb.paper.model.PaperDetailStructBlueprint;
import com.qmth.cqb.paper.service.PaperDetailInfoStructBlueprintService;
import com.qmth.cqb.paper.service.PaperDetailInfoUnitStructBlueprintService;
import com.qmth.cqb.paper.service.PaperDetailStructBlueprintService;

/**
 * @describle 蓝图试卷结构大题 paperDetailStructBlueprintServiceImpl
 * @author weiwenhai
 * @date   2017.11.20
 */
@Service("paperDetailStructBlueprintService")
public class PaperDetailStructBlueprintServiceImpl implements PaperDetailStructBlueprintService{

	@Autowired
	private PaperDetailStructBlueprintRepo paperDetailStructBlueprintRepo;
	
	@Autowired
	private PaperDetailInfoStructBlueprintService paperDetailInfoStructBlueprintService;
	
	@Autowired
	private PaperDetailInfoUnitStructBlueprintService paperDetailInfoUnitStructBlueprintService;
	
	@Override
	public List<PaperDetailStructBlueprint> findAll(Long paperStructBlueprintId) {
		List<PaperDetailStructBlueprint> paperDetailStructBlueprints = paperDetailStructBlueprintRepo.findByPaperStructBlueprintId(paperStructBlueprintId);
		return paperDetailStructBlueprints;
	}

	@Override
	public List<PaperDetailStructBlueprint> findSaveAll(Long userId, Long paperStructBlueprintId) {
		List<PaperDetailStructBlueprint> paperDetailStructBlueprints = paperDetailStructBlueprintRepo.findByUserIdAndPaperStructBlueprintId(userId, paperStructBlueprintId);
		return paperDetailStructBlueprints;
	}
	
	@Override
	public void saveSingle(PaperDetailStructBlueprint paperDetailStructBlueprint) {
		if(!StringUtils.isEmpty(paperDetailStructBlueprint.getName())){
			paperDetailStructBlueprintRepo.save(paperDetailStructBlueprint);
		}
	}

	@Override
	public void deleteSingle(Long id) {
		//查询大题
		PaperDetailStructBlueprint paperDetailStructBlueprint = paperDetailStructBlueprintRepo.findOne(id);
		//查询大题详情
		PaperDetailInfoStructBlueprint paperDetailInfoStructBlueprint = paperDetailInfoStructBlueprintService.getPaperDetailInfoStructBlueprint(id);
		//查询大题详情属性
		List<PaperDetailInfoUnitStructBlueprint> paperDetailInfoUnitStructBlueprints = paperDetailInfoUnitStructBlueprintService.getPaperDetailInfoUnitStructBlueprint(paperDetailInfoStructBlueprint.getId(), id);
		if(paperDetailInfoUnitStructBlueprints != null && paperDetailInfoUnitStructBlueprints.size() >0){
			for(PaperDetailInfoUnitStructBlueprint paperDetailInfoUnitStructBlueprint:paperDetailInfoUnitStructBlueprints){
				paperDetailInfoUnitStructBlueprintService.deleteSingle(paperDetailInfoUnitStructBlueprint);
			}
		}
		if(paperDetailInfoStructBlueprint != null){
			paperDetailInfoStructBlueprintService.deleteSingle(paperDetailInfoStructBlueprint);
		}
		paperDetailStructBlueprintRepo.delete(paperDetailStructBlueprint);
	}

}
